import { Ref, PropType, VNode } from 'vue';
import { Placement, Strategy, Middleware } from '@floating-ui/dom';
import { AuthUpdateOptions } from './useFloating';
import { OriginClassResolver } from './origin-class-resolvers';
interface ArrowState {
    ref: Ref<HTMLElement | null>;
    placement: Ref<Placement>;
    x: Ref<number | undefined>;
    y: Ref<number | undefined>;
}
export declare function useArrowContext(component: string): ArrowState;
export declare const Float: import("vue").DefineComponent<{
    placement: {
        type: PropType<Placement>;
        default: string;
    };
    strategy: {
        type: PropType<Strategy>;
        default: string;
    };
    offset: NumberConstructor;
    shift: {
        type: (NumberConstructor | BooleanConstructor)[];
        default: number;
    };
    flip: {
        type: BooleanConstructor;
        default: boolean;
    };
    arrow: {
        type: (NumberConstructor | BooleanConstructor)[];
        default: boolean;
    };
    autoPlacement: {
        type: (BooleanConstructor | ObjectConstructor)[];
        default: boolean;
    };
    hide: {
        type: BooleanConstructor;
        default: boolean;
    };
    autoUpdate: {
        type: PropType<boolean | AuthUpdateOptions>;
        default: boolean;
    };
    zIndex: {
        type: NumberConstructor;
        default: number;
    };
    enter: StringConstructor;
    enterFrom: StringConstructor;
    enterTo: StringConstructor;
    leave: StringConstructor;
    leaveFrom: StringConstructor;
    leaveTo: StringConstructor;
    portal: {
        type: (StringConstructor | BooleanConstructor)[];
        default: boolean;
    };
    originClass: PropType<string | OriginClassResolver>;
    tailwindcssOriginClass: {
        type: BooleanConstructor;
        default: boolean;
    };
    middleware: {
        type: PropType<Middleware[]>;
        default: () => never[];
    };
}, () => VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>[] | undefined, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, ("show" | "hide")[], "show" | "hide", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    placement: {
        type: PropType<Placement>;
        default: string;
    };
    strategy: {
        type: PropType<Strategy>;
        default: string;
    };
    offset: NumberConstructor;
    shift: {
        type: (NumberConstructor | BooleanConstructor)[];
        default: number;
    };
    flip: {
        type: BooleanConstructor;
        default: boolean;
    };
    arrow: {
        type: (NumberConstructor | BooleanConstructor)[];
        default: boolean;
    };
    autoPlacement: {
        type: (BooleanConstructor | ObjectConstructor)[];
        default: boolean;
    };
    hide: {
        type: BooleanConstructor;
        default: boolean;
    };
    autoUpdate: {
        type: PropType<boolean | AuthUpdateOptions>;
        default: boolean;
    };
    zIndex: {
        type: NumberConstructor;
        default: number;
    };
    enter: StringConstructor;
    enterFrom: StringConstructor;
    enterTo: StringConstructor;
    leave: StringConstructor;
    leaveFrom: StringConstructor;
    leaveTo: StringConstructor;
    portal: {
        type: (StringConstructor | BooleanConstructor)[];
        default: boolean;
    };
    originClass: PropType<string | OriginClassResolver>;
    tailwindcssOriginClass: {
        type: BooleanConstructor;
        default: boolean;
    };
    middleware: {
        type: PropType<Middleware[]>;
        default: () => never[];
    };
}>> & {
    onShow?: ((...args: any[]) => any) | undefined;
    onHide?: ((...args: any[]) => any) | undefined;
}, {
    placement: Placement;
    strategy: Strategy;
    middleware: Middleware[];
    arrow: number | boolean;
    hide: boolean;
    shift: number | boolean;
    flip: boolean;
    autoPlacement: boolean | Record<string, any>;
    autoUpdate: boolean | AuthUpdateOptions;
    zIndex: number;
    portal: string | boolean;
    tailwindcssOriginClass: boolean;
}>;
export declare const FloatArrow: import("vue").DefineComponent<{}, () => VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, import("vue").EmitsOptions, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}>;
export {};
